﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using System.Data;
using System.Collections;

public partial class Tickets_315028_Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        
    }

    protected void RadGrid1_ColumnCreated(object sender, GridColumnCreatedEventArgs e)
    {
        if (e.Column.UniqueName == "Name")
        {
            (e.Column as GridBoundColumn).ReadOnly = true;
        }

        if (e.Column.UniqueName.StartsWith("Select"))
        {
            e.Column.HeaderStyle.Width = Unit.Pixel(20);
        }
    }

    protected void RadGrid1_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
    {
        if (Session["Data"] == null || !Page.IsPostBack)
        {
            Session["Data"] = Data.Load();
        }

        RadGrid1.DataSource = (List<Data>)Session["Data"];
    }

    protected Data GetDataItemByName(string name)
    {
        List<Data> data = (List<Data>)Session["Data"];
        foreach(Data item in data)
        {
            if (item.Name == name)
            {
                return item;
            }
        }

        return null;
    }

    protected void RadGrid1_ItemCreated(object sender, GridItemEventArgs e)
    {
        if (e.Item is GridEditableItem && e.Item.IsInEditMode)
        {
            GridEditableItem item = (GridEditableItem)e.Item;
            
            CheckBox select1Checkbox = (CheckBox)item["Select1"].Controls[0];
            select1Checkbox.AutoPostBack = true;
            select1Checkbox.CheckedChanged += new EventHandler(UpdateEditedItem);

            CheckBox select2Checkbox = (CheckBox)item["Select2"].Controls[0];
            select2Checkbox.AutoPostBack = true;
            select2Checkbox.CheckedChanged += new EventHandler(UpdateEditedItem);
        }
    }

    protected void UpdateEditedItem(object sender, EventArgs e)
    {
        CheckBox selectCheckBox = (CheckBox)sender;
        GridEditableItem item = (GridEditableItem)selectCheckBox.NamingContainer;

        Hashtable values = new Hashtable();
        item.ExtractValues(values);

        Data dataItem = GetDataItemByName(item.GetDataKeyValue("Name").ToString());
        dataItem.Select1 = (bool)values["Select1"];
        dataItem.Select2 = (bool)values["Select2"];

        RadGrid1.Rebind();

    }

    protected void Page_PreRender(object sender, EventArgs e)
    {
        foreach (GridDataItem item in RadGrid1.MasterTableView.Items)
        {
            item.Edit = true;
        }

        RadGrid1.Rebind();
    }
}

public class Data
{
    public string Name { get; set; }
    public bool Select1 { get; set; }
    public bool Select2 { get; set; }

    public Data(string name, bool select1, bool select2)
    {
        Name = name;
        Select1 = select1;
        Select2 = select2;
    }

    public static List<Data> Load()
    {
        List<Data> data = new List<Data>();
        for (int i = 0; i < 25; i++)
        {
            data.Add(new Data(String.Format("Data{0}", i), true, false));
        }
        return data;
    }
}